Pip = class("Pip",StatefulObject)

function Pip:initialize(x,y,dnaArray,team)
super.initialize(self)
self.x = x
self.y = y
self.vx = 0
self.vy = 0
self.health = 100
self.strength = 10
self.speed = 1
self.lifetime = 100
self.dnaArray = dnaArray
self:dnaAnalyze()
self.team = team
end

function Pip:update()
self.x = self.x + self.vx
self.y = self.y + self.vy
	if self.harvesting == true then
		if os.difftime(os.time(),self.harvestTimer)>self.harvestTime then
			-- self.destinationType = "FUCK"
			self:findDestination()
		end
	else
	self:destinationCheck()
	end
end

function Pip:draw()

end

function Pip:newDestination(x,y,destinationType)
self.dx = x
self.dy = y
self.destinationType = destinationType
self:direction()
end

function Pip:destinationCheck()
	if distanceFrom(self.x,self.y,self.dx,self.dy)<4 then
		Game.destination = true
		self:findDestination()
	end 
end

function Pip:direction()
local yDistance = (self.dy - self.y)
local xDistance = (self.dx - self.x)
local squared = math.sqrt((xDistance*xDistance)+(yDistance*yDistance))
local radian = math.atan2(yDistance, xDistance)
self.vx = math.cos(radian)*self.speed
self.vy = math.sin(radian)*self.speed

end

function Pip:findNearestProducer()
local closestDistance = 100000
local closestNumber = 0
	for n=1,#Game.Player[self.team].Producer do
		local distance = distanceFrom(self.x,self.y,Game.Player[self.team].Producer[n].x,Game.Player[self.team].Producer[n].y)
		if distance < closestDistance then
			closestDistance = distance
			closest = n
		end
	end
	self:newDestination(Game.Player[self.team].Producer[closest].x,Game.Player[self.team].Producer[closest].y,"Producer")
end

function Pip:findNearestResource(resourceType)
local closestDistance = 100000
self.resourceNumber = 0
	for n=1, #Game.Map.Resource do
		if Game.Map.Resource[n].resourceType == resourceType and Game.Map.Resource[n].isUsed == false then
			local distance = distanceFrom(self.x,self.y,Game.Map.Resource[n].x,Game.Map.Resource[n].y)
			if distance < closestDistance then
				closestDistance = distance
				self.resourceNumber = n
			end
		end
	end
	if self.resourceNumber ~= 0 then
		Game.Map.Resource[self.resourceNumber].isUsed = true
		self:newDestination(Game.Map.Resource[self.resourceNumber].x,Game.Map.Resource[self.resourceNumber].y,resourceType)
	end
end

function Pip:harvest()
self.destinationType = "Harvest"
self.harvesting = true
self.vx = 0
self.vy = 0
self.dx = 0
self.dy = 0
self.harvestTimer = os.time()
end

function Pip:dnaAnalyze()
	-- Strength/Health
	if string.sub(self.dnaArray,1,1) == "0" then
		self.strength = self.strength*1.25
		self.health = self.health *.75
	else
		self.health = self.health *1.25
		self.strength = self.strength*.75
	end
	-- Speed/Health
	if string.sub(self.dnaArray,2,2) == "0" then
		self.health = self.health *.75
		self.speed = self.speed*1.25
	else
		self.health = self.health *1.25
		self.speed = self.speed*.75
	end	
	-- Lifetime/Health
	if string.sub(self.dnaArray,3,3) == "0" then
		self.lifetime = self.lifetime*1.25
		self.health = self.health *.75
	else
		self.health = self.health *1.25
		self.lifetime = self.lifetime*.75
	end
	-- Strength/Speed
	if string.sub(self.dnaArray,4,4) == "0" then
		self.strength = self.strength*1.25
		self.speed = self.speed *.75
	else
		self.speed = self.speed *1.25
		self.strength = self.strength*.75
	end
	-- Strength/Lifetime
	if string.sub(self.dnaArray,5,5) == "0" then
		self.strength = self.strength*1.25
		self.lifetime = self.lifetime *.75
	else
		self.lifetime = self.lifetime *1.25
		self.strength = self.strength*.75
	end
	-- Speed/Lifetime
	if string.sub(self.dnaArray,6,6) == "0" then
		self.speed = self.speed*1.25
		self.lifetime = self.lifetime *.75
	else
		self.lifetime = self.lifetime *1.25	
		self.speed = self.speed*.75
	end
	-- Pip Selection State
	-- Collector Pips
	if string.sub(self.dnaArray,7,8) == "00" then
		self.pipType = "Chip"
		self:gotoState("ChipCollector")
	elseif string.sub(self.dnaArray,7,8) == "01" then
		self.pipType = "Dip"
		self:gotoState("DipCollector")
	-- Combat Pips
	elseif string.sub(self.dnaArray,7,8) == "10" then
		self.pipType = "Attacker"
		self:gotoState("Attacker")
	else
		self.pipType = "Defender"
		self:gotoState("Defender")
	end
end

function Pip:checkState()

end

--[[
Pip States needed-
Harvesting
Moving
Fighting



--]]


