local  Play = Game:addState("Play")

function Play:enterState()
Game.producerLock = 0
Game.dnaChoice = 1
Game.dna = {"1","0","0","1","1","1","0","1"}
Game.dnaNameLeft ={
"strength", "speed","life","strength","strength","speed","Collect","Chip" }
Game.dnaNameRight = {
"health", "health","health","speed","life","life","Fight","Dip" }
-- love.graphics.setBackgroundColor(238,254,255)
-- Game.floater = {}
-- for n=1,20 do
-- Game.floater[n] = {
-- x=math.random(-Game.width,0),
-- y=math.random(0,Game.height),
-- vx= math.random(1,5)/10,
-- vy = math.random(1,5)/10,
-- image=1,
-- r = math.random(1,3)}
-- end

love.graphics.setBackgroundColor(10,10,16)
love.keyboard.setKeyRepeat(100, 20 )
love.mouse.setVisible(false)
	if Game.started == false then
		Game:newGame()
	end
	Game.startTime = os.time()
end

function Play:update()
Game.Map:update()
	for n=1,#Game.Player do
		Game.Player[n]:update()
	end
	if Game.dna[7] == "1" then
		Game.dnaNameLeft[8] = "Attack"
		Game.dnaNameRight[8] = "Defend"
	else
		Game.dnaNameLeft[8] = "Chip"
		Game.dnaNameRight[8] = "Dip"	
	end
-- Play:updateFloater()
end

function Play:draw()
-- Draws Map
-- love.graphics.setColor(255,255,255,128)
-- Play:drawFloater()
-- love.graphics.setColor(255,255,255,255)
Game.Map:draw()
-- Draws Player
	for n=1,#Game.Player do
		Game.Player[n]:draw()
	end
	if Game.debug then
		Play:drawDebug()
	end
		Play:drawGUI()

	love.graphics.setColor(255,255,255)
end

function Play:drawGUI()
love.graphics.setFont(debugFont)
	love.graphics.draw(dnaGraphic,Game.width-375,50)
	love.graphics.draw(indicatorGraphic,Game.width-254,Game.dnaChoice*64-110)
	for n=1,8 do
	love.graphics.setColor(255,255,255)	
		if Game.dna[n] == "1" then
			if n % 2 == 0 then
				love.graphics.draw(ATConnectedGraphic,Game.width-255,n*64)
			else
				love.graphics.draw(CGConnectedGraphic,Game.width-255,n*64)
			end
			love.graphics.setColor(255,0,0)
			love.graphics.print(Game.dnaNameRight[n],Game.width-55,n*64-12)		
			love.graphics.setColor(255,255,255)		
			love.graphics.printf(Game.dnaNameLeft[n],Game.width-438,n*64-12,250,"right")
	
		else
			if n % 2 == 0 then
				love.graphics.draw(ATDisconnectedGraphic,Game.width-255,n*64)
			else
				love.graphics.draw(CGDisconnectedGraphic,Game.width-255,n*64)
			end
			love.graphics.setColor(255,0,0)
			love.graphics.printf(Game.dnaNameLeft[n],Game.width-438,n*64-12,250,"right")			
			love.graphics.setColor(255,255,255)		
			love.graphics.print(Game.dnaNameRight[n],Game.width-55,n*64-12)					
		end
		-- love.graphics.print(Game.dna[n],Game.width-50,n*60)


	end
end

function Play:updateFloater()
	for n=1,#Game.floater do
		Game.floater[n].x = Game.floater[n].x + Game.floater[n].vx
		Game.floater[n].y = Game.floater[n].y + Game.floater[n].vy
	end	
end

function Play:drawFloater()
	for n=1,#Game.floater do
		love.graphics.draw(floaterGraphic[Game.floater[n].image],Game.floater[n].x,Game.floater[n].y,Game.floater[n].r)
	end	
end


function Play:keypressed(key)
	if key == "escape" then
		Game:gotoState("Menu")
	end
	if key == "`" then
		Game.debug = not Game.debug
	end
	if key == "a" or key == "kp4"  then 
		Game.Camera:move(-8,0)
	end
	if key == "d" or key == "kp6" then
		Game.Camera:move(8,0)
	end
	if key == "s" or key == "kp2"  then
		Game.Camera:move(0,8)
	end
	if key == "w" or key == "kp8"  then
		Game.Camera:move(0,-8)
	end
	if key == "kp1" then
		Game.Camera:move(-8,8)
	end
	if key == "kp3" then
		Game.Camera:move(8,8)
	end
	if key == "kp7" then
		Game.Camera:move(-8,-8)
	end
	if key == "kp9" then
		Game.Camera:move(8,-8)
	end
	if key == "down" then
	Game.dnaChoice = Game.dnaChoice + 1
		if Game.dnaChoice == 9 then
			Game.dnaChoice = 1
		end
	end
	if key == "up" then
	Game.dnaChoice = Game.dnaChoice - 1
		if Game.dnaChoice == 0 then
		Game.dnaChoice = 8
		end
	end
	if key == "right" then
		if Game.dna[Game.dnaChoice] == "1" then
			Game.dna[Game.dnaChoice] = "0"
		else
			Game.dna[Game.dnaChoice] = "1"
		end
		Game.Player[1].Producer[1].dnaArray = Game.dna[1] .. Game.dna[2] ..Game.dna[3] ..
			Game.dna[4] ..Game.dna[5] .. Game.dna[6] ..Game.dna[7] ..Game.dna[8]
	end

	if key == "x" then
		local x = math.random(1,Game.Map.width)
		local y = math.random(1,Game.Map.height)
		Game.Player[math.random(1,4)]:newProducer(x,y)
	end
	local keyToNumber = tonumber(key)
	if keyToNumber ~= nil then
		Game.producerLock = keyToNumber
		Game.Camera:moveToProducer(Game.producerLock)
	end
end

function Play:exitState()

end

function Play:drawDebug()
love.graphics.print(Game.Camera.x .. ", " .. Game.Camera.y,0,10)
love.graphics.print(os.difftime(os.time(),Game.startTime),0,30)

end

function Game:newGame()
	Game.debug = false
	Game.Map = Map:new(Game.width*4,Game.height*4)
	Game.Player = {}
	for n=1,4 do
		Game.Player[n] = Player:new(n)
		Game.Player[n]:placeHQ()
		if n == 1 then
			Game.Player[n]:gotoState("HumanPlayer")
		else
			Game.Player[n]:gotoState("AIPlayer")
		end
		
	end
	Game.Camera = Camera:new()
	Game.started = true
	-- Game.framebuffer = love.graphics.newFramebuffer()
end



