Player = class("Player",StatefulObject)

function Player:initialize(n)
	super.initialize(self)
	self.number = n
	self.Producer = {}
	self.Pip = {}
end

function Player:update()
	for n=1,#self.Producer do
		self.Producer[n]:update()
	end
	for n=1,#self.Pip do
		self.Pip[n]:update()
	end
end

function Player:draw()
	for n=1, #self.Producer do
		self.Producer[n]:draw()
	end
	for n=1, #self.Pip do
		self.Pip[n]:draw()
	end
end

function Player:newPip()
self.Pip[#self.Pip+1] = Pip:new()
end

local HumanPlayer = Player:addState("HumanPlayer")

function HumanPlayer:enterState()

end

local AIPlayer = Player:addState("AIPlayer")

function AIPlayer:enterState()

end

function Player:newProducer(x,y)
	if #self.Producer<9 then
		self.Producer[#self.Producer+1] = Producer:new(x,y,self.number)
	end
end

function Player:placeHQ()
local x = 1
local y = 1
	if self.number % 2 == 1 then
		x = round(Game.Map.width/4,0)
	else
		x = round((Game.Map.width/4)*3,0)
	end
	if self.number < 3 then
		y = round(Game.Map.height/4,0)
	else
		y = round((Game.Map.height/4)*3,0)
	end
	self.Producer[1] = Producer:new(x,y,self.number)
end


